CREATE OR REPLACE VIEW V_NNFIRMA_ID_OR_NULL AS (
  SELECT DISTINCT (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'MarinaLocationsModule') = 0 THEN NULL ELSE ID END) AS ID FROM NNFIRMA
);

CREATE OR REPLACE VIEW V_KUPCI_SALDAKONTI AS (
SELECT CONCAT(CONCAT(K.ID, CASE WHEN N.ID IS NULL THEN '' ELSE '-' END), N.ID) AS V_KUPCI_SALDAKONTI_ID, K.ID AS KUPCI_ID, N.ID AS NNFIRMA_ID, K.VALUTA_PLACILA,
  (CASE WHEN K.VALUTA_PLACILA IS NULL OR K.VALUTA_PLACILA = (SELECT DOMACAVALUTA FROM PARAM) THEN 'Y' ELSE 'N' END) AS KUPCI_DOMACA_VALUTA,
  -- Parcialne ponudbe, domaca valuta
  (
    SELECT SUM(M.OPEN_AMOUNT)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P' AND M.CONFIRMED = 'Y'
  ) AS SALDAKONTI_PART_PROFORMA_SIT,
  
   -- Parcialne ponudbe, tuja valuta (skupajVal*openAmount/skupaj)
  (
    (SELECT COALESCE(SUM(M.SKUPAJ_VAL), 0)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P' AND M.CONFIRMED = 'Y') 
    * (SELECT COALESCE(SUM(M.OPEN_AMOUNT), 0)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P' AND M.CONFIRMED = 'Y')
    / (SELECT CASE WHEN (COALESCE(SUM(M.SKUPAJ), 0) = 0) THEN 1 ELSE SUM(M.SKUPAJ) END
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P' AND M.CONFIRMED = 'Y')
  ) AS SALDAKONTI_PART_PROFORMA_DEM,
  
  -- Ponudbe, domaca valuta
  (
    SELECT SUM(M.SKUPAJ)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P'
  ) AS SALDAKONTI_PROFORMA_SIT,
  
  -- Ponudbe, tuja valuta
  (
    SELECT SUM(M.SKUPAJ_VAL)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P'
  ) AS SALDAKONTI_PROFORMA_DEM,
  
  -- Saldo, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
  ) AS SALDAKONTI_SIT,
  
  -- Saldo, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
  ) AS SALDAKONTI_DEM,
  
  -- Saldo odprti, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
  ) AS SALDAKONTI_OUTSTANDING_SIT,
  
   -- Saldo odprti, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
  ) AS SALDAKONTI_OUTSTANDING_DEM,
  
   -- Saldo prejeti, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    
  ) AS SALDAKONTI_RECEIVED_SIT,
  
   -- Saldo prejeti, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    
  ) AS SALDAKONTI_RECEIVED_DEM,
  
  -- Depoziti, domaca valuta
  (
    SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
      AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM) <= TRUNC(SYSDATE)
      AND S.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
  ) DEPOSIT_SIT,
  
   -- Depoziti, tuja valuta
  (
    SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
      AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM) <= TRUNC(SYSDATE)
      AND S.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
  ) DEPOSIT_DEM

FROM KUPCI K, V_NNFIRMA_ID_OR_NULL N
);


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1087, SYSDATE, '5.5', 1007, 'Saldo kupca')
;