ALTER TABLE CONTRACT_EXTENSION_RULE
ADD PRICE_CALCULATION VARCHAR2(3 CHAR);

ALTER TABLE CONTRACT_EXTENSION_RULE
ADD PRICE_CHANGE_VALUE NUMBER;

ALTER TABLE CONTRACT_EXTENSION_RULE
ADD PRICE_CHANGE_TYPE VARCHAR2(3 CHAR);

UPDATE M_NNSTOMAR
SET SETTINGS = (CASE WHEN SETTINGS IS NULL THEN 'P' ELSE SETTINGS || ';P' END)
WHERE (SETTINGS IS NULL OR UPPER(SETTINGS) NOT LIKE '%P%')
AND FILTER IN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'POG');

CREATE OR REPLACE VIEW V_POGODBE AS (
	SELECT P.ID_POGODBE AS V_POGODBE_ID, P.ID_POGODBE, P.ID_LASTNIKA, P.ID_PLOVILA, P.ID_MASTER, P.OBJEKT, P.N_PRIVEZA, P.N_POGODBE, P.DATUM_ZACETKA, P.DATUM_KONCA, P.PREDVIDENI_DATUM_KONCA, P.DATUM_KREIRANJA, P.USER_KREIRANJA,
  P.DATUM_SPREMEMBE, P.USER_SPREMEMBE, P.STATUS, P.DATUM_SKLENITVE, P.DATUM_PREKINITVE, P.KOMENTAR, P.TIP_POGODBE, P.EXTENSION_SEQUENCE_NUMBER, P.EXTENSION_DATE,
  NNSTAT.OPIS AS STATUS_OPIS, NNSTAT.INTERNI_OPIS AS STATUS_INTERNI_OPIS,
  KUPVRS.VRSTA AS CURRENT_KUPCI_VRSTA, PLOV.IME AS PLOVILA_IME, PLOV.PODALJSA AS PLOVILA_PODALJSA, KUP.IME AS KUPCI_IME, KUP.PRIIMEK AS KUPCI_PRIIMEK,
  NP.ID_PRIVEZ AS NNPRIVEZ_ID_PRIVEZ, NP.KATEGORIJA AS NNPRIVEZ_KATEGORIJA, NO.STORAGE AS NNOBJEKT_STORAGE,
  NNLOC.ID AS NNLOCATION_ID
	FROM M_POGODBE P
	LEFT OUTER JOIN NNSTATPOG NNSTAT ON P.STATUS = NNSTAT.SIFRA
  LEFT OUTER JOIN PLOVILA PLOV ON PLOV.ID = P.ID_PLOVILA
  LEFT OUTER JOIN KUPCI KUP ON KUP.ID = P.ID_LASTNIKA
  LEFT OUTER JOIN NNPRIVEZ NP ON P.OBJEKT = NP.OBJEKT AND P.N_PRIVEZA = NP.N_PRIVEZA
  LEFT OUTER JOIN NNOBJEKT NO ON NO.SIFRA = NP.OBJEKT 
  LEFT OUTER JOIN NNPOMOL NPOM ON NPOM.SIFRA = NP.KATEGORIJA
  LEFT OUTER JOIN NNLOCATION NNLOC ON NNLOC.ID = NPOM.NNLOCATION_ID
  LEFT OUTER JOIN (SELECT KUPCI_VRSTA.*, RANK() OVER (PARTITION BY ID_KUPCA ORDER BY ID_KUPCI_VRSTA DESC) RNK FROM KUPCI_VRSTA) KUPVRS ON (KUPVRS.ID_KUPCA = P.ID_LASTNIKA AND KUPVRS.RNK = 1)
);

CREATE OR REPLACE VIEW V_M_VZORCI_PS_VALUE AS (
  SELECT M.ID_VPS, M.SKUPAJ, M.FULL_AMOUNT, 
  COALESCE(M.SKUPAJ, 0) * (1-COALESCE(M.POPUST, 0)/100) * (1-COALESCE(M.POPUST1, 0)/100) * (1-COALESCE(M.POPUST2, 0)/100) * (1-COALESCE(M.PROVIZIJA, 0)/100) AS NETO_DOMACA_VREDNOST,
  COALESCE(M.SKUPAJ, 0) * (1-COALESCE(M.POPUST, 0)/100) * (1-COALESCE(M.POPUST1, 0)/100) * (1-COALESCE(M.POPUST2, 0)/100) * (1-COALESCE(M.PROVIZIJA, 0)/100) * (1+COALESCE(M.DAVEK, 0)/100) AS BRUTO_DOMACA_VREDNOST
  FROM M_VZORCI_PS M
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1386, SYSDATE, '5.5', 1306, 'Contract extension rule')
;